#!/usr/bin/perl -T
# $Id: prelogin.cgi,v 1.11 2020/08/19 08:25:08 sqko Exp $
############################################################
############################################################
###                                                      ###
###   Originally designed by Soeren Koch                 ###
###                                                      ###
###   Impelemented by Soeren Koch                        ###
###                                                      ###
###   Copyright by Soeren Koch January 2005 - 2011       ###
###                                                      ###
############################################################
############################################################

use strict;
use warnings;
use RFC::Main;
use RFC::RFCCGI qw(:cgi :html);
use RFC::Header;
use RFC::Furnace;
use SocketClient;
use CGI qw(:standard :netscape);
use Sys::Hostname qw(hostname);
my $ssl = 0;
$ssl = 1 if (CGI::https());
print header();
print '<link rel="shortcut icon" href="/Celltest.ico">',"\n";
print '<script src="/celltest/RFCcontrol.js"></script>',"\n";
print &my_start_html(-title=>$name, -style=>{src=>'/RFCfurnace/Furnace.css'});
print '<table  class=top_table>';
print '<col width=20%, span=5>';
print '<tr>';
print "\n";
print '<td>';
print button(-name=>'Login',-value=>'Login',-class=>'s3',-onclick=>'windowOpen()');
print '</td>';
top_no_button;
top_no_button;
top_no_button;
if (defined(param('action')))
{
    &Localbutton('Menu','s3');
}
else
{
    top_no_button;
}
end_top_bar;

print "\n",'<script lanuage="javascript">',"\n";
print 'function checkjs() {',"\n";
print '  document.login.jscheck.value = 1;',"\n";
print '}',"\n";

my $mystring = '';
my @l = localtime();

print <<END;

function windowOpen() {
    $mystring
    var myWindow=window.open('../../celltest/popup.html','windowRef','width=450,height=100,left=300,top=200');
    myWindow.location.href = '../../celltest/popup.html';
    if (!myWindow.opener)
        myWindow.opener = self;
    myWindow.focus();
}

function go()
{
    document.login.action.click();
}

function change_water(x,y)
{
    if (document.fu.elements[x].checked)
    {
	document.fu.elements[y].disabled = false;
    }
    else
    {
	document.fu.elements[y].disabled = true;
    }
}
</script>
END


print start_form(-name=>'login',-class=>"form",-onsubmit=>'return checkjs()',-action=>'login.cgi');
print hidden(-name=>'jscheck',-value=>'0',-force=>'1');
print hidden(-name=>'name',-value=>'',-value=>'1');
print hidden(-name=>'pass',-value=>'',-value=>'1');
print hidden(-name=>'rig',-value=>0,-force=>1);
print submit(-name=>'action',-value=>'Login',-class=>'hidden');
print end_form;

param(-name=>'action',-value=>'') unless (param('action'));
$_ = param('action');
 CASE:
{
    ### Insert case statements ###
    /show_rigs/ and do {&show_rigs(); last CASE;};
    ### Default response ####
    &main_form;
}	
&print_end('../RFCfurnace/manual.pdf');
exit;




sub Localbutton($$$)
{
    my $name = shift;
    my $class = shift;
    print '<td>';
    print start_form();
    if (@_)
    {
	my $action = shift;
	action($action);
    }
    print submit(-name=>$name,-class=>$class);
    print end_form;
    print '</td>';
}


sub main_form
{
    print '<center>';
    print h1("Welcome to RFCfurnace");
    my $server = `/bin/hostname`;
    $server =~ /([\w\-]+)/;
    $server = $1;
    my @list = ();
    my @listservers = ();
    my $listserver = get_cv('servers','listserver');
    if ($listserver)
    {
	chomp $listserver;
	my $str = &RFC::Main::report_client($listserver,'servers');
	my @l;
	@l = split(/[\t\s]+/,$str) if ($str && $str !~ /ERROR/);
	foreach (@l)
	{
	    if (/([\w\.\-]+)/)
	    {
		push @list,$1;
	    }
	}
        $str= &RFC::Main::report_client($listserver,'list_servers');
        @l = split(/\t/,$str) if ($str && $str !~ /ERROR/);
        foreach (@l)
        {
            if (/([\w\.\-]+)/)
            {
                push @listservers,$1;
            }
        }
    }
    if (@listservers && @listservers > 1)
    {
        print h3("Avaliable listservers");
        print '<table border=0 cellspacing=10 cellpadding=0><tr>';
        foreach my $s (sort @listservers)
        {
            print '<td>';
            my $ss = 'http://'.$s;
            if ($ssl)
            {
                print start_form(-action=>'https://'.$s.'/cgi-bin/RFCfurnace/prelogin.cgi');
		$ss = 'https://'.$s if (CGI::https());	
            }
            else
            {
                print start_form(-action=>'http://'.$s.'/cgi-bin/RFCfurnace/prelogin.cgi');
            }
	    &action('show_rigs');
	    print submit(-name=>'dummy',-value=>$s,-class=>'main1',-id=>'list_'.$s);
            print end_form();
            print '</td>';
	    print <<END;

<script>
    get_server_name('$ss',function(res){if (!res) {return false;};document.getElementById('list_'+'$s').value = res});
</script>

END

        }
        print '</tr></table>';
    }
    if (@list)
    {
	print p('&nbsp;');
	print h1("Select furnace group");
	print '<table class="main_select">',"\n";
        foreach my $s (sort @list)
        {
            print '<tr>';
            my $str = &RFC::Main::report_client($s,'active_rigs');
            my $ss = 'http://'.$s;
            $ss = 'https://'.$s if (CGI::https());
            my @l = ();
            @l = split(/\t/,$str) if ($str);
            print '<td>';
            if (CGI::https())
            {
                print start_form(-action=>'https://'.$s.'/cgi-bin/RFCfurnace/prelogin.cgi');
            }
            else
            {
                print start_form(-action=>'http://'.$s.'/cgi-bin/RFCfurnace/prelogin.cgi');
            }
            &action('show_rigs');
            &print_hidden();
            print submit(-name=>'dummy',-value=>$s,-class=>'main2',-id=>$s);
            print end_form();
            print '</td>';
            print <<END;

<script>
    get_server_name('$ss',function(res){if (!res) {return false;};document.getElementById('$s').value = res});
</script>
END

            if (@l && $l[0] =~ /error/i)
	{
	    print "<th colspan=12>Error: Could not contact server '$s'</th>";
	    &errorlog($l[0]);
	    next;
	}
        }
        print '</tr>',"\n";
    }
    else
    {
	print h3({-class=>'Alert'},"Error: Could not get server list from from '$listserver', using local list only");
	print '<table border=0 cellspacing=10 cellpadding=10>';
	print '<tr><td colspan=10 class="heading">';
	print "Data on all furnaces:";
	print '</td></tr><tr>';
	my $str = get_cv('celltest','rigs');
	$str = '' unless defined($str);
	my @l = split(/\s*\,\s*/,$str);
	my $count = 0;
	foreach my $r (sort {$a <=> $b} (@l))
	{
	    if ($count > 5)
	    {
		print "</tr><tr>\n";
		$count = 0;
	    }
	    print '<td>';
	    print start_form(-action=>'/rig'.$r.'/furnace_runs/',-method=>'GET');
	    menu_button('test',"Furnace $r",'s0');
	    print end_form();
	    print '</td>';
	    $count++;
	}
    }
    print '</table>';
    print '</center>';
}    

sub show_rigs()
{
    my $name = &get_cv('global','server_name');
    $name = hostname unless ($name);
    my @list = ();
    print '<center>';
    print h1("Welcome to $name");
    my $str = get_cv('celltest','rigs');
    $str = '' unless defined($str);

    print '<table border=0 cellspacing=10 cellpadding=10>';
    print '<tr><td colspan='.scalar(@l).' class="heading">';
    print "Select furnace:";
    print '</td></tr><tr>';
    my $count = 0;
    my @l = split(/\s*\,\s*/,$str);
    foreach my $r (sort {$a <=> $b} (@l))
    {
	if ($count > 5)
	{
		print "</tr><tr>\n";
		$count = 0;
	}
	push @list,$r;
#	my $temp = &get_atemp($r);
	print '<td>';
#	print "<button type=submit class=main4 id=$r onclick='document.login.rig.value=$r;windowOpen()'> Furnace $r ($temp) </button>";
	print "<button type=submit class=main4 id=$r onclick='document.login.rig.value=$r;windowOpen()'> Furnace $r </button>";
#	print button(-name=>'login',-value=>'furnace '.$r,-id=>$r,-class=>'main4',-onclick=>"document.login.rig.value=$r;windowOpen()");
	print '</td>';
	$count++;
    }
#    print '<tr><td colspan='.scalar(@l).' class="heading">';
#    print "Data on all furnace runs:";
#    print '</td></tr><tr>';
#    foreach my $r (sort {$a <=> $b} (@l))
#    {
#	print '<td>';
#	print start_form(-action=>'/rig'.$r.'/furnace_runs',-method=>'GET');
#	menu_button('test',"Furnace $r",'s0');
#	print end_form();
#	print '</td>';
#    }
    print '</table>';
    print '</center>';
    &print_js(@list) if (@list);
}



sub my_start_html
#####################################################################
### Nescesarry for bugfix of tab width WTF!!!                    ####
#####################################################################
{
    my %h = @_;
    my $onload = 0;
    my $time = &get_cv('global','logoutdelay');
    $time =~ /(\d+)/;
    $time = $1+0;
    $time = ($time * 60 * 1000) - 10000;
    print "<script lanuage=\"javascript\">\n";
    print "function doAlertLogout() {\n";
    print "    var tt = setTimeout('alert(\\'You have been automatically logged out!\\');',$time);\n";
    print "}\n";
    print "</script>\n";
    for my $key (keys %h)
    {
        if ($key =~ /-onload/i)
        {
            my $str = $h{$key};
            my $e = '';
            if ($str =~ /([\'\"])$/)
            {
                $e = $1;
                $str =~ s/[\'\"]$//;
            }
            $str = $str . ';doAlertLogout();'.$e;
            $h{$key} = $str;
            $onload = 1;
        }
    }
    return start_html(%h);
}


sub print_js(@)
{
    print start_form(-name=>'login_info');
    print_hidden_rig;
    print hidden(-name=>'time');
    print hidden(-name=>'jscheck');
    print end_form();
    my @fnlist = ();
    foreach my $x (@_)
    {
        push @fnlist,"   run_ajax('ajax_furnace.cgi','&action=status&furnace=$x',function(res){set_status($x,res)});";
    }
    my $str = join("\n",@fnlist);
    print <<END;

<script>

function check_all()
{
$str   
    setTimeout(check_all,60000);
}

function set_status(id,status)
{
    var e = document.getElementById(id);
    var val = e.innerHTML;
    var reg = /<br>/;
    if (reg.test(val))
    {
        var info = val.split('<br>');
        e.innerHTML = info[0] + '<br>'+status;
    }
    else
    {
        e.innerHTML = e.innerHTML + '<br>'+status;
    }
    if (status == 'Running')
    {   
        e.className = 'main6';
    }
    else
    {
        e.className = 'main4';
    }
}

check_all();
</script>
END
}


sub get_atemp($)
{
    my $r = shift;
    my $temp = ' - ';
    eval {
        my $rig = RFC::Rig->new($r);
        my $furnace = RFC::Furnace->new($rig);
        $temp = sprintf("%.0f",$furnace->get_atemp()).' C';
    };
    return $temp;
}
